<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: src/RayTracer.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_ray_tracer_8hpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">RayTracer.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_ray_tracer_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * eduRayTracer - An Educational Ray Tracing Software Package</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Contributor(s): Pedro Santana - ISCTE-IUL (2014-2016)</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#ifndef _H_RayTracer_</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#define _H_RayTracer_</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_scene_8hpp.html">Scene.hpp</a>&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_camera_8hpp.html">Camera.hpp</a>&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div><div class="line"><a name="l00014"></a><span class="lineno"><a class="line" href="_ray_tracer_8hpp.html#a59491c5991850e50f02d5196e1ed5264">   14</a></span>&#160;<span class="keyword">inline</span> <span class="keywordtype">double</span> <a class="code" href="_ray_tracer_8hpp.html#a59491c5991850e50f02d5196e1ed5264">clamp</a>(<span class="keywordtype">double</span> x){ <span class="keywordflow">return</span> x&lt;0 ? 0 : x&gt;1 ? 1 : x; }</div><div class="line"><a name="l00015"></a><span class="lineno"><a class="line" href="_ray_tracer_8hpp.html#a8d0a9e9e4bc37a5ae80b8bf3856b807e">   15</a></span>&#160;<span class="keyword">inline</span> <span class="keywordtype">int</span> <a class="code" href="_ray_tracer_8hpp.html#a8d0a9e9e4bc37a5ae80b8bf3856b807e">toInt</a>(<span class="keywordtype">double</span> x){ <span class="keywordflow">return</span> int(pow(<a class="code" href="_ray_tracer_8hpp.html#a59491c5991850e50f02d5196e1ed5264">clamp</a>(x),1/2.2)*255+.5); }</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">//inline int toInt(double x){ return int(x*255); }</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="class_ray_tracer.html">   20</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_ray_tracer.html">RayTracer</a> {</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="keywordtype">double</span> tmp;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00028"></a><span class="lineno"><a class="line" href="class_ray_tracer.html#ac9cdbb6f2d03e8c1fe9895ac87d64589">   28</a></span>&#160;    <a class="code" href="class_scene.html">Scene</a> *<a class="code" href="class_ray_tracer.html#ac9cdbb6f2d03e8c1fe9895ac87d64589">scene</a>;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    </div><div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="class_ray_tracer.html#a920e316dba30cabe8f44f61354dcdd83">   31</a></span>&#160;    <a class="code" href="class_camera.html">Camera</a> *<a class="code" href="class_ray_tracer.html#a920e316dba30cabe8f44f61354dcdd83">camera</a>;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="class_ray_tracer.html#addc15de08e27710ac4fd444dec9319b5">   34</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a>* <a class="code" href="class_ray_tracer.html#addc15de08e27710ac4fd444dec9319b5">image</a>;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno"><a class="line" href="class_ray_tracer.html#a7181bf515b74ec7d8d89b055b48b1d88">   37</a></span>&#160;    <span class="keywordtype">char</span>* <a class="code" href="class_ray_tracer.html#a7181bf515b74ec7d8d89b055b48b1d88">pixels</a>;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="class_ray_tracer.html#a352f7cb6352afbc395bac32df143982e">   40</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="class_ray_tracer.html#a352f7cb6352afbc395bac32df143982e">samples</a>;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno"><a class="line" href="class_ray_tracer.html#aca8693132318560401e7196689f2aaf3">   43</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="class_ray_tracer.html#aca8693132318560401e7196689f2aaf3">shadow_samples</a>;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00046"></a><span class="lineno"><a class="line" href="class_ray_tracer.html#a93125040fd72bb71d06678bdcc0bbf08">   46</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="class_ray_tracer.html#a93125040fd72bb71d06678bdcc0bbf08">hops</a>;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <a class="code" href="class_ray_tracer.html#a82688d0457a19e0a96f389ef9b89f729">RayTracer</a>(<a class="code" href="class_camera.html">Camera</a> *_camera, <a class="code" href="class_scene.html">Scene</a> *_scene);</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_ray_tracer.html#a5a7a1453c882cf71dc64827e343c1ae4">render</a>();</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00062"></a><span class="lineno"><a class="line" href="class_ray_tracer.html#a529ef735a2c804625b8e4e6208eec9b7">   62</a></span>&#160;    <a class="code" href="class_scene.html">Scene</a>* <a class="code" href="class_ray_tracer.html#a529ef735a2c804625b8e4e6208eec9b7">getScene</a>(){<span class="keywordflow">return</span> <a class="code" href="class_ray_tracer.html#ac9cdbb6f2d03e8c1fe9895ac87d64589">scene</a>;}</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    </div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno"><a class="line" href="class_ray_tracer.html#a93e5af568fdcc8f5d6a45cead69fe337">   68</a></span>&#160;    <a class="code" href="class_camera.html">Camera</a>* <a class="code" href="class_ray_tracer.html#a93e5af568fdcc8f5d6a45cead69fe337">getCamera</a>(){<span class="keywordflow">return</span> <a class="code" href="class_ray_tracer.html#a920e316dba30cabe8f44f61354dcdd83">camera</a>;}</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    </div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno"><a class="line" href="class_ray_tracer.html#ae355f48cf8bd6ee996c204cde4f851dc">   74</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_ray_tracer.html#ae355f48cf8bd6ee996c204cde4f851dc">setNrAntiAliasingSamples</a>(<span class="keywordtype">int</span> _samples){samples = _samples;};</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160; </div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div><div class="line"><a name="l00080"></a><span class="lineno"><a class="line" href="class_ray_tracer.html#acaf0197e36cd4b7dc85dc42d1fe0b60a">   80</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_ray_tracer.html#acaf0197e36cd4b7dc85dc42d1fe0b60a">setNrShadowSamples</a>(<span class="keywordtype">int</span> _shadow_samples){shadow_samples = _shadow_samples;};</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    </div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;</div><div class="line"><a name="l00086"></a><span class="lineno"><a class="line" href="class_ray_tracer.html#ac8442d74a14bb488634460d587e5ac48">   86</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_ray_tracer.html#ac8442d74a14bb488634460d587e5ac48">setDepthRayRecursion</a>(<span class="keywordtype">int</span> _hops){hops = _hops;};</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    <span class="keywordtype">int</span> <a class="code" href="class_ray_tracer.html#a51007e02e88d5213dd47284360fcae45">get_visible_surface</a>(<span class="keywordtype">int</span> i, <span class="keywordtype">int</span> j, <a class="code" href="structhit__rec.html">hit_rec</a> &amp;h_r);</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_ray_tracer.html#afb77b881327160bda0aa9dd0bae7a5f5">get_pixel_from_3D</a>(<a class="code" href="class_vec.html">Vec</a> point, <a class="code" href="class_vec.html">Vec</a> &amp;pixel);</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_ray_tracer.html#ada62841980d0982da632d6aa53081538">ray_shading</a>(<a class="code" href="class_scene.html">Scene</a> *scene, <a class="code" href="class_ray.html">Ray</a> &amp;ray, <span class="keywordtype">int</span> hops);</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_ray_tracer.html#a4239f82baac1501dc9bd5884e2b5eddc">get_shadding</a>(<a class="code" href="structhit__rec.html">hit_rec</a> &amp;h_r, <span class="keywordtype">bool</span> bump);</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    </div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_ray_tracer.html#aaa54f1ee77877741364c27665d4088ab">shadow_rays</a>(<a class="code" href="class_scene.html">Scene</a> *scene, <a class="code" href="structhit__rec.html">hit_rec</a> h_r, <a class="code" href="class_light.html">Light</a>* light, <a class="code" href="class_vec.html">Vec</a> rnd);</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_ray_tracer.html#a8f974dd303bcdb1de773d6fccf3127f0">save_to_file</a>();</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;};</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="class_ray_tracer_html_aaa54f1ee77877741364c27665d4088ab"><div class="ttname"><a href="class_ray_tracer.html#aaa54f1ee77877741364c27665d4088ab">RayTracer::shadow_rays</a></div><div class="ttdeci">Vec shadow_rays(Scene *scene, hit_rec h_r, Light *light, Vec rnd)</div><div class="ttdoc">Casts a shadow ray recursively from a given surface point to a Light source. Returns how much light i...</div><div class="ttdef"><b>Definition:</b> RayTracer.cpp:109</div></div>
<div class="ttc" id="_ray_tracer_8hpp_html_a8d0a9e9e4bc37a5ae80b8bf3856b807e"><div class="ttname"><a href="_ray_tracer_8hpp.html#a8d0a9e9e4bc37a5ae80b8bf3856b807e">toInt</a></div><div class="ttdeci">int toInt(double x)</div><div class="ttdef"><b>Definition:</b> RayTracer.hpp:15</div></div>
<div class="ttc" id="class_light_html"><div class="ttname"><a href="class_light.html">Light</a></div><div class="ttdoc">A class to create and manipulate light sources. </div><div class="ttdef"><b>Definition:</b> Light.hpp:16</div></div>
<div class="ttc" id="class_ray_tracer_html_a352f7cb6352afbc395bac32df143982e"><div class="ttname"><a href="class_ray_tracer.html#a352f7cb6352afbc395bac32df143982e">RayTracer::samples</a></div><div class="ttdeci">int samples</div><div class="ttdoc">Number of samples used for anti-aliasing. </div><div class="ttdef"><b>Definition:</b> RayTracer.hpp:40</div></div>
<div class="ttc" id="class_camera_html"><div class="ttname"><a href="class_camera.html">Camera</a></div><div class="ttdoc">A class to create and manipulate virtual projective cameras. </div><div class="ttdef"><b>Definition:</b> Camera.hpp:20</div></div>
<div class="ttc" id="class_ray_tracer_html_a82688d0457a19e0a96f389ef9b89f729"><div class="ttname"><a href="class_ray_tracer.html#a82688d0457a19e0a96f389ef9b89f729">RayTracer::RayTracer</a></div><div class="ttdeci">RayTracer(Camera *_camera, Scene *_scene)</div><div class="ttdoc">A RayTracer constructor. </div><div class="ttdef"><b>Definition:</b> RayTracer.cpp:11</div></div>
<div class="ttc" id="class_ray_tracer_html_a93e5af568fdcc8f5d6a45cead69fe337"><div class="ttname"><a href="class_ray_tracer.html#a93e5af568fdcc8f5d6a45cead69fe337">RayTracer::getCamera</a></div><div class="ttdeci">Camera * getCamera()</div><div class="ttdoc">Returns a pointer to the Camera object. </div><div class="ttdef"><b>Definition:</b> RayTracer.hpp:68</div></div>
<div class="ttc" id="class_ray_tracer_html_aca8693132318560401e7196689f2aaf3"><div class="ttname"><a href="class_ray_tracer.html#aca8693132318560401e7196689f2aaf3">RayTracer::shadow_samples</a></div><div class="ttdeci">int shadow_samples</div><div class="ttdoc">Number of shadow rays for soft shadows. </div><div class="ttdef"><b>Definition:</b> RayTracer.hpp:43</div></div>
<div class="ttc" id="class_ray_tracer_html_ae355f48cf8bd6ee996c204cde4f851dc"><div class="ttname"><a href="class_ray_tracer.html#ae355f48cf8bd6ee996c204cde4f851dc">RayTracer::setNrAntiAliasingSamples</a></div><div class="ttdeci">void setNrAntiAliasingSamples(int _samples)</div><div class="ttdoc">Sets the number of samples used for anti-aliasing. </div><div class="ttdef"><b>Definition:</b> RayTracer.hpp:74</div></div>
<div class="ttc" id="class_ray_tracer_html_a5a7a1453c882cf71dc64827e343c1ae4"><div class="ttname"><a href="class_ray_tracer.html#a5a7a1453c882cf71dc64827e343c1ae4">RayTracer::render</a></div><div class="ttdeci">void render()</div><div class="ttdoc">Triggers the rendering process by creating viewing rays and tracing them across the scene by calling ...</div><div class="ttdef"><b>Definition:</b> RayTracer.cpp:228</div></div>
<div class="ttc" id="class_ray_tracer_html_a4239f82baac1501dc9bd5884e2b5eddc"><div class="ttname"><a href="class_ray_tracer.html#a4239f82baac1501dc9bd5884e2b5eddc">RayTracer::get_shadding</a></div><div class="ttdeci">Vec get_shadding(hit_rec &amp;h_r, bool bump)</div><div class="ttdoc">Applies the shading equation on the point defined in a given hit record. </div><div class="ttdef"><b>Definition:</b> RayTracer.cpp:20</div></div>
<div class="ttc" id="class_ray_tracer_html_ada62841980d0982da632d6aa53081538"><div class="ttname"><a href="class_ray_tracer.html#ada62841980d0982da632d6aa53081538">RayTracer::ray_shading</a></div><div class="ttdeci">Vec ray_shading(Scene *scene, Ray &amp;ray, int hops)</div><div class="ttdef"><b>Definition:</b> RayTracer.cpp:145</div></div>
<div class="ttc" id="class_ray_tracer_html_ac9cdbb6f2d03e8c1fe9895ac87d64589"><div class="ttname"><a href="class_ray_tracer.html#ac9cdbb6f2d03e8c1fe9895ac87d64589">RayTracer::scene</a></div><div class="ttdeci">Scene * scene</div><div class="ttdoc">Pointer to the Scene to be rendered. </div><div class="ttdef"><b>Definition:</b> RayTracer.hpp:28</div></div>
<div class="ttc" id="class_ray_tracer_html_acaf0197e36cd4b7dc85dc42d1fe0b60a"><div class="ttname"><a href="class_ray_tracer.html#acaf0197e36cd4b7dc85dc42d1fe0b60a">RayTracer::setNrShadowSamples</a></div><div class="ttdeci">void setNrShadowSamples(int _shadow_samples)</div><div class="ttdoc">Sets the number of shadow rays for soft shadows. </div><div class="ttdef"><b>Definition:</b> RayTracer.hpp:80</div></div>
<div class="ttc" id="class_scene_html"><div class="ttname"><a href="class_scene.html">Scene</a></div><div class="ttdoc">A class to create and control scenes from Surface and Light objects. </div><div class="ttdef"><b>Definition:</b> Scene.hpp:23</div></div>
<div class="ttc" id="class_ray_tracer_html_ac8442d74a14bb488634460d587e5ac48"><div class="ttname"><a href="class_ray_tracer.html#ac8442d74a14bb488634460d587e5ac48">RayTracer::setDepthRayRecursion</a></div><div class="ttdeci">void setDepthRayRecursion(int _hops)</div><div class="ttdoc">Sets the number of recursive ray tracing hops (secondary rays). </div><div class="ttdef"><b>Definition:</b> RayTracer.hpp:86</div></div>
<div class="ttc" id="class_ray_tracer_html"><div class="ttname"><a href="class_ray_tracer.html">RayTracer</a></div><div class="ttdoc">A class to create and manipulate surface materials. </div><div class="ttdef"><b>Definition:</b> RayTracer.hpp:20</div></div>
<div class="ttc" id="class_ray_tracer_html_a529ef735a2c804625b8e4e6208eec9b7"><div class="ttname"><a href="class_ray_tracer.html#a529ef735a2c804625b8e4e6208eec9b7">RayTracer::getScene</a></div><div class="ttdeci">Scene * getScene()</div><div class="ttdoc">Returns a pointer to the Scene object. </div><div class="ttdef"><b>Definition:</b> RayTracer.hpp:62</div></div>
<div class="ttc" id="class_ray_tracer_html_a920e316dba30cabe8f44f61354dcdd83"><div class="ttname"><a href="class_ray_tracer.html#a920e316dba30cabe8f44f61354dcdd83">RayTracer::camera</a></div><div class="ttdeci">Camera * camera</div><div class="ttdoc">Pointer to the rendering Camera. </div><div class="ttdef"><b>Definition:</b> RayTracer.hpp:31</div></div>
<div class="ttc" id="class_ray_tracer_html_a8f974dd303bcdb1de773d6fccf3127f0"><div class="ttname"><a href="class_ray_tracer.html#a8f974dd303bcdb1de773d6fccf3127f0">RayTracer::save_to_file</a></div><div class="ttdeci">void save_to_file()</div><div class="ttdoc">Saves the last rendering to a .ppm file with a timestamped name. </div><div class="ttdef"><b>Definition:</b> RayTracer.cpp:299</div></div>
<div class="ttc" id="class_vec_html"><div class="ttname"><a href="class_vec.html">Vec</a></div><div class="ttdoc">A class to create and manipulate 3D vectors. These can be used to store positions, normals, and RGB triplets. </div><div class="ttdef"><b>Definition:</b> Vec.hpp:16</div></div>
<div class="ttc" id="class_ray_tracer_html_a51007e02e88d5213dd47284360fcae45"><div class="ttname"><a href="class_ray_tracer.html#a51007e02e88d5213dd47284360fcae45">RayTracer::get_visible_surface</a></div><div class="ttdeci">int get_visible_surface(int i, int j, hit_rec &amp;h_r)</div><div class="ttdoc">Returns the index of the visible Surface object on a given pixel. It does this by finding the closest...</div><div class="ttdef"><b>Definition:</b> RayTracer.cpp:186</div></div>
<div class="ttc" id="class_ray_tracer_html_a93125040fd72bb71d06678bdcc0bbf08"><div class="ttname"><a href="class_ray_tracer.html#a93125040fd72bb71d06678bdcc0bbf08">RayTracer::hops</a></div><div class="ttdeci">int hops</div><div class="ttdoc">Number of recursive ray tracing hops (secondary rays) </div><div class="ttdef"><b>Definition:</b> RayTracer.hpp:46</div></div>
<div class="ttc" id="class_ray_tracer_html_addc15de08e27710ac4fd444dec9319b5"><div class="ttname"><a href="class_ray_tracer.html#addc15de08e27710ac4fd444dec9319b5">RayTracer::image</a></div><div class="ttdeci">Vec * image</div><div class="ttdoc">Floating point rendered image. </div><div class="ttdef"><b>Definition:</b> RayTracer.hpp:34</div></div>
<div class="ttc" id="_scene_8hpp_html"><div class="ttname"><a href="_scene_8hpp.html">Scene.hpp</a></div></div>
<div class="ttc" id="class_ray_tracer_html_a7181bf515b74ec7d8d89b055b48b1d88"><div class="ttname"><a href="class_ray_tracer.html#a7181bf515b74ec7d8d89b055b48b1d88">RayTracer::pixels</a></div><div class="ttdeci">char * pixels</div><div class="ttdoc">8-bit rendered image (built from image) </div><div class="ttdef"><b>Definition:</b> RayTracer.hpp:37</div></div>
<div class="ttc" id="class_ray_html"><div class="ttname"><a href="class_ray.html">Ray</a></div><div class="ttdoc">A class to create and manipulate 3D rays. </div><div class="ttdef"><b>Definition:</b> Ray.hpp:12</div></div>
<div class="ttc" id="_ray_tracer_8hpp_html_a59491c5991850e50f02d5196e1ed5264"><div class="ttname"><a href="_ray_tracer_8hpp.html#a59491c5991850e50f02d5196e1ed5264">clamp</a></div><div class="ttdeci">double clamp(double x)</div><div class="ttdef"><b>Definition:</b> RayTracer.hpp:14</div></div>
<div class="ttc" id="class_ray_tracer_html_afb77b881327160bda0aa9dd0bae7a5f5"><div class="ttname"><a href="class_ray_tracer.html#afb77b881327160bda0aa9dd0bae7a5f5">RayTracer::get_pixel_from_3D</a></div><div class="ttdeci">void get_pixel_from_3D(Vec point, Vec &amp;pixel)</div><div class="ttdoc">Returns the projection, in pixel coordinates, of a given 3D point. </div><div class="ttdef"><b>Definition:</b> RayTracer.cpp:207</div></div>
<div class="ttc" id="structhit__rec_html"><div class="ttname"><a href="structhit__rec.html">hit_rec</a></div><div class="ttdoc">A structure used to hold information regarding ray-surface intersection events. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:20</div></div>
<div class="ttc" id="_camera_8hpp_html"><div class="ttname"><a href="_camera_8hpp.html">Camera.hpp</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="_ray_tracer_8hpp.html">RayTracer.hpp</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
